timestepratio=2;
testfunction=1;
xmin=0; xmax=1; Nx=10;
x=linspace(xmin,xmax,Nx)';
dx=x(2)-x(1);
dt0=dx^2/2;
dt=dt0/timestepratio;
tmin=0; tmax=5;
Nt=round((tmax-tmin)/dt);
t=linspace(tmin,tmax,Nt)';
dt=t(2)-t(1);
fprintf('dx: %f - dt: %f - dt/(dx^2/2): %f\n',...
    dt,dx,dt/(dx^2/2))
fprintf('Nx: %i - Nt: %i\n',Nx,Nt)

U=zeros(Nx,Nt);
U(:,1)=mysol(x,t(1),testfunction);
tic
for nt=2:Nt
    U(:,nt)=heateq(U(:,nt-1),x,t(nt),dt,testfunction);
end
tim=toc;
fprintf('Tempo=%f s\n',tim)

figure(1)
clf;
set(gcf,'Name','Eq. calore')
subplot(1,2,1)
plot(x,U(:,Nt))
xlabel('x')
ylabel('u')
title(['Soluzione a t=' num2str(t(Nt))])
subplot(1,2,2)
surf(t,x,U)
xlabel('t')
ylabel('x')
zlabel('u')
shading interp
title(['Soluzione a t=' num2str(t(Nt))])



























